(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     25690,        675]
NotebookOptionsPosition[     24245,        625]
NotebookOutlinePosition[     24893,        649]
CellTagsIndexPosition[     24850,        646]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["\<\
uso de la funcion perturbadora de Murray
http://ssdbook.maths.qmul.ac.uk/addinfo/notebook.html
Curso Mecanica Celeste de Maestria
Tabare Gallardo, 2020\
\>", "Section",
 CellChangeTimes->{{3.417634761515625*^9, 3.417634764859375*^9}, {
  3.417637791984375*^9, 3.41763782209375*^9}, {3.8048478176687365`*^9, 
  3.80484782852284*^9}, {3.804848691729471*^9, 3.804848695913945*^9}, {
  3.80484875218281*^9, 3.8048487551094646`*^9}}],

Cell[TextData[{
 "\nWe start by loading the ",
 StyleBox["DisturbingFunction", "Input"],
 " package.  In this example it is assumed that the file ",
 StyleBox["DisturbingFunction.m",
  FontWeight->"Bold"],
 " is located in the current directory/folder."
}], "Text",
 CellFrame->True,
 CellChangeTimes->{{3.8048487809404736`*^9, 3.8048487831683407`*^9}},
 Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell["<<DisturbingFunction.m;", "Input",
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"SetDelayed", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(ValidArguments\\)\[NoBreak] in \
\[NoBreak]\\!\\(ValidArguments[\\(\\(c1_, c2_, n_Integer\\)\\)]\\)\[NoBreak] \
is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.804847955044361*^9, 3.80484797105949*^9}, 
   3.804848059766464*^9, 3.804848093988699*^9, 3.8048481484312773`*^9, 
   3.80484827181837*^9, 3.8048484683410606`*^9, 3.8048485508426886`*^9, 
   3.8048791606441574`*^9, {3.8048792461064386`*^9, 3.804879265367342*^9}, 
   3.8048793008336544`*^9, 3.8048793700032153`*^9, 3.8048794725254197`*^9, 
   3.8048798773029118`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"SetDelayed", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(IndirectTestE\\)\[NoBreak] in \
\[NoBreak]\\!\\(IndirectTestE[\\(\\({clamdap_, clamda_, clpp_Integer, \
clp_Integer, clanp_Integer, clan_Integer}\\)\\)]\\)\[NoBreak] is Protected. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/write\\\", \
ButtonNote -> \\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.804847955044361*^9, 3.80484797105949*^9}, 
   3.804848059766464*^9, 3.804848093988699*^9, 3.8048481484312773`*^9, 
   3.80484827181837*^9, 3.8048484683410606`*^9, 3.8048485508426886`*^9, 
   3.8048791606441574`*^9, {3.8048792461064386`*^9, 3.804879265367342*^9}, 
   3.8048793008336544`*^9, 3.8048793700032153`*^9, 3.8048794725254197`*^9, 
   3.8048798774016476`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"SetDelayed", "::", "write"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Tag \[NoBreak]\\!\\(ValidArgumentsE\\)\[NoBreak] in \
\[NoBreak]\\!\\(ValidArgumentsE[\\(\\(c1_, c2_, pmax_Integer\\)\\)]\\)\
\[NoBreak] is Protected. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/write\\\", ButtonNote -> \
\\\"SetDelayed::write\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.804847955044361*^9, 3.80484797105949*^9}, 
   3.804848059766464*^9, 3.804848093988699*^9, 3.8048481484312773`*^9, 
   3.80484827181837*^9, 3.8048484683410606`*^9, 3.8048485508426886`*^9, 
   3.8048791606441574`*^9, {3.8048792461064386`*^9, 3.804879265367342*^9}, 
   3.8048793008336544`*^9, 3.8048793700032153`*^9, 3.8048794725254197`*^9, 
   3.804879877506367*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \
\[NoBreak]\\!\\(\\*StyleBox[\\(SetDelayed :: write\\), \
\\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this calculation. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/stop\\\", \
ButtonNote -> \\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.804847955044361*^9, 3.80484797105949*^9}, 
   3.804848059766464*^9, 3.804848093988699*^9, 3.8048481484312773`*^9, 
   3.80484827181837*^9, 3.8048484683410606`*^9, 3.8048485508426886`*^9, 
   3.8048791606441574`*^9, {3.8048792461064386`*^9, 3.804879265367342*^9}, 
   3.8048793008336544`*^9, 3.8048793700032153`*^9, 3.8048794725254197`*^9, 
   3.804879877557232*^9}]
}, Open  ]],

Cell[TextData[{
 "Show how the function ",
 StyleBox["DisturbingFunctionE", "Input"],
 " is used. Le pido todos los coeficientes hasta cierto orden que multiplican \
cierto coseno. Supongo perturbador Externo. Es analogo con ",
 StyleBox["DisturbingFunctionI ", "Input"],
 "para el caso de perturbador interno."
}], "Text",
 CellFrame->True,
 CellChangeTimes->{{3.8048488113372784`*^9, 3.8048488599251957`*^9}, {
  3.804849000488055*^9, 3.8048490260286703`*^9}, {3.8048491072377033`*^9, 
  3.8048491381397357`*^9}},
 Background->GrayLevel[0.849989]],

Cell[BoxData[
 RowBox[{"DisturbingFunctionE", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", "4"}], "]"}]], "Input",
 CellChangeTimes->{{3.804798027417101*^9, 3.8047980884998183`*^9}, {
  3.804798139026822*^9, 3.804798205200696*^9}, {3.804798250230276*^9, 
  3.8047982511668673`*^9}, {3.8047983433656616`*^9, 3.804798344647541*^9}, {
  3.8047984856469646`*^9, 3.804798487076666*^9}, {3.8047985284792585`*^9, 
  3.804798601569724*^9}, {3.80479863616545*^9, 3.8047987570604563`*^9}, {
  3.804798792031349*^9, 3.8047987941223907`*^9}, {3.8047988733215775`*^9, 
  3.8047988736688385`*^9}, {3.8047989050134473`*^9, 3.804798971764079*^9}, {
  3.8047991585466423`*^9, 3.8047992048393416`*^9}, {3.8047992820304356`*^9, 
  3.8047993049671125`*^9}, {3.804799364521785*^9, 3.8047993647436*^9}, {
  3.8048479262521667`*^9, 3.8048479673141856`*^9}, {3.8048792430081673`*^9, 
  3.80487927389847*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   SuperscriptBox["a", "\[Prime]",
    MultilineFunction->None]], 
  RowBox[{"\[ScriptCapitalG]", " ", 
   RowBox[{"Cos", "[", 
    RowBox[{"\[Lambda]", "+", "\[CurlyPi]", "+", "\[CapitalOmega]", "-", 
     SuperscriptBox["\[Lambda]", "\[Prime]",
      MultilineFunction->None], "-", 
     SuperscriptBox["\[CurlyPi]", "\[Prime]",
      MultilineFunction->None], "-", 
     SuperscriptBox["\[CapitalOmega]", "\[Prime]",
      MultilineFunction->None]}], "]"}], " ", 
   SuperscriptBox["m", "\[Prime]",
    MultilineFunction->None], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["5", "2"], " ", "e", " ", "s", " ", "\[Alpha]", " ", 
      RowBox[{"b", "[", 
       RowBox[{
        FractionBox["3", "2"], ",", "3", ",", "0"}], "]"}], " ", 
      SuperscriptBox["e", "\[Prime]",
       MultilineFunction->None], " ", 
      SuperscriptBox["s", "\[Prime]",
       MultilineFunction->None]}], "-", 
     RowBox[{"e", " ", "s", " ", 
      SuperscriptBox["\[Alpha]", "2"], " ", 
      RowBox[{"b", "[", 
       RowBox[{
        FractionBox["3", "2"], ",", "3", ",", "1"}], "]"}], " ", 
      SuperscriptBox["e", "\[Prime]",
       MultilineFunction->None], " ", 
      SuperscriptBox["s", "\[Prime]",
       MultilineFunction->None]}], "-", 
     RowBox[{
      FractionBox["1", "4"], " ", "e", " ", "s", " ", 
      SuperscriptBox["\[Alpha]", "3"], " ", 
      RowBox[{"b", "[", 
       RowBox[{
        FractionBox["3", "2"], ",", "3", ",", "2"}], "]"}], " ", 
      SuperscriptBox["e", "\[Prime]",
       MultilineFunction->None], " ", 
      SuperscriptBox["s", "\[Prime]",
       MultilineFunction->None]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.804798474831534*^9, 3.80479849374403*^9}, 
   3.804798542633171*^9, {3.8047985787658997`*^9, 3.804798605907572*^9}, {
   3.80479864692134*^9, 3.8047987806626887`*^9}, {3.80479887018155*^9, 
   3.8047988816989126`*^9}, {3.8047989122362394`*^9, 3.804798922682695*^9}, {
   3.804798955810465*^9, 3.804798977480463*^9}, {3.8047991799316654`*^9, 
   3.8047992093929377`*^9}, {3.804799296609128*^9, 3.8047993086915855`*^9}, 
   3.8047993682891545`*^9, {3.804847947538918*^9, 3.8048479713683405`*^9}, 
   3.8048480600646896`*^9, 3.8048480945040627`*^9, 3.8048481487432027`*^9, 
   3.8048482721681757`*^9, 3.804848468837756*^9, 3.804848551217876*^9, 
   3.8048791609932227`*^9, {3.8048792467731647`*^9, 3.8048792658959274`*^9}, 
   3.8048793012056584`*^9, 3.8048793703632526`*^9, 3.8048794730744624`*^9, 
   3.804879877684152*^9}],

Cell[TextData[{
 StyleBox["ValidArguments[j1,j2,orden] ", "Input"],
 "da una lista de todos los argumentos que incluyen la combinacion j1*lambda\
\[CloseCurlyQuote] + j2*lambda y que poseen coeficientes hasta cierto orden "
}], "Text",
 CellFrame->True,
 CellChangeTimes->{{3.8048488113372784`*^9, 3.804848992397002*^9}, {
  3.804849175079664*^9, 3.8048491757000113`*^9}, {3.8098732844322815`*^9, 
  3.809873288387416*^9}},
 Background->GrayLevel[0.849989]],

Cell[CellGroupData[{

Cell["argum = ValidArguments[0,0,2]", "Input",
 CellChangeTimes->{{3.4190755049375*^9, 3.4190755054375*^9}, {
   3.41916185284375*^9, 3.41916185328125*^9}, {3.657890636106887*^9, 
   3.6578906367788076`*^9}, 3.8048480536127524`*^9, {3.804848085841736*^9, 
   3.8048480908609314`*^9}, {3.804848250369011*^9, 3.804848252216758*^9}, 
   3.8048490699311037`*^9, 3.8048793410579395`*^9, {3.8048797382744913`*^9, 
   3.804879745018013*^9}, {3.804879869096376*^9, 3.8048798694366684`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "1", ",", 
     RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.804848060079013*^9, 3.8048480945183077`*^9, 3.804848148760126*^9, 
   3.8048482721883235`*^9, 3.8048484688610764`*^9, 3.8048485512429285`*^9, 
   3.804879161027134*^9, {3.804879246795106*^9, 3.804879265910889*^9}, 
   3.804879301229598*^9, 3.8048793703812046`*^9, 3.8048794730904202`*^9, 
   3.8048797577268505`*^9, 3.804879877705091*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["desa = Map[DisturbingFunctionE[#,2]&,argum]", "Input",
 CellChangeTimes->{{3.419075515921875*^9, 3.419075516453125*^9}, {
   3.419161857796875*^9, 3.419161858296875*^9}, {3.6578906422478476`*^9, 
   3.657890642779127*^9}, 3.657891751457287*^9, {3.804848223269128*^9, 
   3.8048482669670315`*^9}, {3.8048483682488213`*^9, 3.804848369378913*^9}, {
   3.804879777453242*^9, 3.8048797782820253`*^9}, {3.804879873693748*^9, 
   3.8048798741640906`*^9}},
 ImageRegion->{{0, 1}, {0, 1}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     SuperscriptBox["a", "\[Prime]",
      MultilineFunction->None]], 
    RowBox[{"\[ScriptCapitalG]", " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "0", ",", "0"}], "]"}]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", 
        SuperscriptBox["e", "2"], " ", "\[Alpha]", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "0", ",", "1"}], "]"}]}], "+", 
       RowBox[{
        FractionBox["1", "8"], " ", 
        SuperscriptBox["e", "2"], " ", 
        SuperscriptBox["\[Alpha]", "2"], " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "0", ",", "2"}], "]"}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SuperscriptBox["s", "2"], " ", "\[Alpha]", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["3", "2"], ",", "1", ",", "0"}], "]"}]}], "+", 
       RowBox[{
        FractionBox["1", "4"], " ", "\[Alpha]", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "0", ",", "1"}], "]"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["e", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}], "+", 
       RowBox[{
        FractionBox["1", "8"], " ", 
        SuperscriptBox["\[Alpha]", "2"], " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "0", ",", "2"}], "]"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["e", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[Alpha]", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["3", "2"], ",", "1", ",", "0"}], "]"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["s", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}]}], ")"}]}]}], ",", 
   FractionBox[
    RowBox[{"\[ScriptCapitalG]", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[CurlyPi]", "-", 
       SuperscriptBox["\[CurlyPi]", "\[Prime]",
        MultilineFunction->None]}], "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], " ", "e", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "1", ",", "0"}], "]"}], " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "e", " ", "\[Alpha]", " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "1", ",", "1"}], "]"}], " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}], "-", 
       RowBox[{
        FractionBox["1", "4"], " ", "e", " ", 
        SuperscriptBox["\[Alpha]", "2"], " ", 
        RowBox[{"b", "[", 
         RowBox[{
          FractionBox["1", "2"], ",", "1", ",", "2"}], "]"}], " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}]}], ")"}], " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None]}], 
    SuperscriptBox["a", "\[Prime]",
     MultilineFunction->None]], ",", 
   FractionBox[
    RowBox[{"s", " ", "\[ScriptCapitalG]", " ", "\[Alpha]", " ", 
     RowBox[{"b", "[", 
      RowBox[{
       FractionBox["3", "2"], ",", "1", ",", "0"}], "]"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[CapitalOmega]", "-", 
       SuperscriptBox["\[CapitalOmega]", "\[Prime]",
        MultilineFunction->None]}], "]"}], " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None], " ", 
     SuperscriptBox["s", "\[Prime]",
      MultilineFunction->None]}], 
    SuperscriptBox["a", "\[Prime]",
     MultilineFunction->None]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8048482722734756`*^9, 3.8048484689676404`*^9, 3.8048485513526807`*^9, 
   3.804879161140829*^9, {3.804879246884865*^9, 3.80487926600766*^9}, 
   3.8048793013298397`*^9, 3.804879370493902*^9, 3.804879473190157*^9, 
   3.804879785284686*^9, 3.804879877765439*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"desa2", "=", 
  RowBox[{"desa", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"\[Alpha]", "\[Rule]", "0.4"}], ",", 
     RowBox[{
      RowBox[{"b", "[", 
       RowBox[{"s_", ",", "j_", ",", "nd_"}], "]"}], "\[RuleDelayed]", 
      RowBox[{"LaplaceCoefficient", "[", 
       RowBox[{"s", ",", "j", ",", "\[Alpha]", ",", "nd"}], "]"}]}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.657890357123327*^9, 3.657890401906952*^9}, {
  3.8048483568993187`*^9, 3.8048483765386457`*^9}, {3.804848443329978*^9, 
  3.804848458695319*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     SuperscriptBox["a", "\[Prime]",
      MultilineFunction->None]], 
    RowBox[{"\[ScriptCapitalG]", " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"0.020000000000000004`", " ", 
        SuperscriptBox["e", "2"]}], "+", 
       RowBox[{"0.1`", " ", 
        SuperscriptBox["e", "2"], " ", "\[Alpha]"}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", 
          FractionBox[
           SuperscriptBox["\[Alpha]", "2"], "2"]}], ")"}]}], "-", 
       RowBox[{"0.2`", " ", 
        SuperscriptBox["s", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", "\[Alpha]"}], "+", 
          FractionBox[
           RowBox[{"45", " ", 
            SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}]}], "+", 
       RowBox[{"0.020000000000000004`", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["e", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}], "+", 
       RowBox[{"0.1`", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["e", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}], "-", 
       RowBox[{"0.2`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", "\[Alpha]"}], "+", 
          FractionBox[
           RowBox[{"45", " ", 
            SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["s", "\[Prime]",
           MultilineFunction->None], ")"}], "2"]}]}], ")"}]}]}], ",", 
   FractionBox[
    RowBox[{"\[ScriptCapitalG]", " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[CurlyPi]", "-", 
       SuperscriptBox["\[CurlyPi]", "\[Prime]",
        MultilineFunction->None]}], "]"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "0.09000000000000002`"}], " ", "e", " ", "\[Alpha]", " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}], "-", 
       RowBox[{"0.2`", " ", "e", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          FractionBox[
           RowBox[{"9", " ", 
            SuperscriptBox["\[Alpha]", "2"]}], "8"]}], ")"}], " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "e", " ", 
        RowBox[{"(", 
         RowBox[{"\[Alpha]", "+", 
          FractionBox[
           RowBox[{"3", " ", 
            SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}], " ", 
        SuperscriptBox["e", "\[Prime]",
         MultilineFunction->None]}]}], ")"}], " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None]}], 
    SuperscriptBox["a", "\[Prime]",
     MultilineFunction->None]], ",", 
   FractionBox[
    RowBox[{"0.4`", " ", "s", " ", "\[ScriptCapitalG]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "\[Alpha]"}], "+", 
       FractionBox[
        RowBox[{"45", " ", 
         SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}], " ", 
     RowBox[{"Cos", "[", 
      RowBox[{"\[CapitalOmega]", "-", 
       SuperscriptBox["\[CapitalOmega]", "\[Prime]",
        MultilineFunction->None]}], "]"}], " ", 
     SuperscriptBox["m", "\[Prime]",
      MultilineFunction->None], " ", 
     SuperscriptBox["s", "\[Prime]",
      MultilineFunction->None]}], 
    SuperscriptBox["a", "\[Prime]",
     MultilineFunction->None]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.8048484690229087`*^9, 3.804848551408436*^9, 3.8048791612036605`*^9, {
   3.8048792469337387`*^9, 3.8048792660591383`*^9}, 3.8048793013856926`*^9, 
   3.8048793705796747`*^9, 3.804879473263956*^9, 3.8048798113520837`*^9, 
   3.8048798778113155`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Rpert", "=", 
  RowBox[{"Apply", "[", 
   RowBox[{"Plus", ",", 
    RowBox[{"desa2", " ", "/.", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"e", "'"}], "\[RuleDelayed]", "0.4"}], ",", 
       RowBox[{
        SuperscriptBox["\[CurlyPi]", "\[Prime]",
         MultilineFunction->None], "\[RuleDelayed]", " ", "0"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.417635543390625*^9, 3.417635582828125*^9}, {
  3.4176357673125*^9, 3.417635945046875*^9}, {3.417636175921875*^9, 
  3.417636185078125*^9}, {3.417636253109375*^9, 3.417636263625*^9}, {
  3.417636997421875*^9, 3.417637004625*^9}, {3.657890717001811*^9, 
  3.6578907276586275`*^9}, {3.6578910631920424`*^9, 3.6578910645671096`*^9}, {
  3.657891804913254*^9, 3.65789180536639*^9}, {3.8048485218497505`*^9, 
  3.8048485319078665`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"\[ScriptCapitalG]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "0.03600000000000001`"}], " ", "e", " ", "\[Alpha]"}], 
      "-", 
      RowBox[{"0.08000000000000002`", " ", "e", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         FractionBox[
          RowBox[{"9", " ", 
           SuperscriptBox["\[Alpha]", "2"]}], "8"]}], ")"}]}], "+", 
      RowBox[{"0.2`", " ", "e", " ", 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "+", 
         FractionBox[
          RowBox[{"3", " ", 
           SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}]}]}], ")"}], " ", 
    RowBox[{"Cos", "[", "\[CurlyPi]", "]"}], " ", 
    SuperscriptBox["m", "\[Prime]",
     MultilineFunction->None]}], 
   SuperscriptBox["a", "\[Prime]",
    MultilineFunction->None]], "+", 
  FractionBox[
   RowBox[{"0.4`", " ", "s", " ", "\[ScriptCapitalG]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[Alpha]"}], "+", 
      FractionBox[
       RowBox[{"45", " ", 
        SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}], " ", 
    RowBox[{"Cos", "[", 
     RowBox[{"\[CapitalOmega]", "-", 
      SuperscriptBox["\[CapitalOmega]", "\[Prime]",
       MultilineFunction->None]}], "]"}], " ", 
    SuperscriptBox["m", "\[Prime]",
     MultilineFunction->None], " ", 
    SuperscriptBox["s", "\[Prime]",
     MultilineFunction->None]}], 
   SuperscriptBox["a", "\[Prime]",
    MultilineFunction->None]], "+", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox["a", "\[Prime]",
     MultilineFunction->None]], "\[ScriptCapitalG]", " ", 
   SuperscriptBox["m", "\[Prime]",
    MultilineFunction->None], " ", 
   RowBox[{"(", 
    RowBox[{"0.0032000000000000015`", "\[VeryThinSpace]", "+", 
     RowBox[{"0.020000000000000004`", " ", 
      SuperscriptBox["e", "2"]}], "+", 
     RowBox[{"0.016000000000000004`", " ", "\[Alpha]"}], "+", 
     RowBox[{"0.1`", " ", 
      SuperscriptBox["e", "2"], " ", "\[Alpha]"}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        FractionBox[
         SuperscriptBox["\[Alpha]", "2"], "2"]}], ")"}]}], "-", 
     RowBox[{"0.2`", " ", 
      SuperscriptBox["s", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[Alpha]"}], "+", 
        FractionBox[
         RowBox[{"45", " ", 
          SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}]}], "-", 
     RowBox[{"0.2`", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[Alpha]"}], "+", 
        FractionBox[
         RowBox[{"45", " ", 
          SuperscriptBox["\[Alpha]", "3"]}], "8"]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox["s", "\[Prime]",
         MultilineFunction->None], ")"}], "2"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.8048485514478846`*^9, 3.8048791612674885`*^9, {3.804879246973635*^9, 
   3.804879266094044*^9}, 3.8048793014235888`*^9, 3.8048793706389627`*^9, 
   3.804879473336762*^9, 3.8048798380881405`*^9, 3.8048798778402386`*^9}]
}, Open  ]]
},
ScreenStyleEnvironment->"Presentation",
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{1016, 629},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
ShowCellLabel->True,
ShowCellTags->False,
FrontEndVersion->"10.2 for Microsoft Windows (64-bit) (July 7, 2015)",
StyleDefinitions->"Classroom.nb",
PrivateNotebookOptions -> {"ColorPalette" -> {RGBColor, -1}},
RenderingOptions -> {"ObjectDithering" -> True},
RenderingOptions -> {"RasterDithering" -> False}
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 438, 9, 184, "Section"],
Cell[986, 31, 387, 10, 111, "Text"],
Cell[CellGroupData[{
Cell[1398, 45, 72, 1, 67, "Input"],
Cell[1473, 48, 882, 16, 48, "Message"],
Cell[2358, 66, 936, 16, 119, "Message"],
Cell[3297, 84, 885, 16, 84, "Message"],
Cell[4185, 102, 880, 16, 48, "Message"]
}, Open  ]],
Cell[5080, 121, 549, 12, 81, "Text"],
Cell[5632, 135, 1017, 18, 67, "Input"],
Cell[6652, 155, 2542, 57, 146, "Output"],
Cell[9197, 214, 457, 9, 80, "Text"],
Cell[CellGroupData[{
Cell[9679, 227, 514, 7, 67, "Input"],
Cell[10196, 236, 759, 17, 65, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10992, 258, 486, 7, 67, "Input"],
Cell[11481, 267, 4314, 117, 296, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15832, 389, 561, 14, 67, "Input"],
Cell[16396, 405, 3869, 106, 316, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20302, 516, 855, 19, 67, "Input"],
Cell[21160, 537, 3069, 85, 258, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
